/*******************************************************************************
*   . (C) 1997 Opium Inc., 
*
* :			VsmObject.cpp
*
* :		 . 
*
* :		03.12.2009   09:21
*
* :	VsmObject.h
*
* :		   Winstar WG12864B-XXX-XX
*
*				:	CS=0, E 1->0		:	CS=0, E 0->1
*						E=1, CS 0->1				E=1, CS 1->0
*
*******************************************************************************/

#include "stdafx.h"
#include "VsmObject.h"

#include <stdio.h>
#include <stdlib.h>

//------------------------------------------------------------------------------

CVsmObject::CVsmObject()
{
	m_CntBeforeCheckPins = 0;

	m_DcDisplay		= NULL;
	m_BmpDisplay	= NULL;
	m_OldBmpDisplay	= NULL;

	m_DcPixel		= NULL;
	m_BmpPixel		= NULL;
	m_OldBmpPixel	= NULL;

	for(int i = 0; i < 64; i++)
	{
		m_Chip1.DDRAM_DRAM[i] = 0;
		m_Chip1.DDRAM_DRAW[i] = 0;
		m_Chip2.DDRAM_DRAM[i] = 0;
		m_Chip2.DDRAM_DRAW[i] = 0;
	}
}
//------------------------------------------------------------------------------
CVsmObject::~CVsmObject()
{
	if(m_DcPixel != NULL)
	{
		SelectObject(m_DcPixel, m_OldBmpPixel);
		DeleteObject(m_BmpPixel);
		DeleteDC(m_DcPixel);
	}

	if(m_DcDisplay != NULL)
	{
		SelectObject(m_DcDisplay, m_OldBmpDisplay);
		DeleteObject(m_BmpDisplay);
		DeleteDC(m_DcDisplay);
	}
}
//------------------------------------------------------------------------------
INT CVsmObject::isdigital(CHAR *pinname)
{
	UNREFERENCED_PARAMETER(pinname);

	return 1;
}
//------------------------------------------------------------------------------
VOID CVsmObject::setup(IINSTANCE *inst, IDSIMCKT *dsim)
{
	m_IInstance	= inst;
	m_Ickt		= dsim;

	m_DB[0] = m_IInstance->getdsimpin("DB0,db0", true);
	m_DB[0]->setstate(FLT);
	m_DB[1] = m_IInstance->getdsimpin("DB1,db1", true);
	m_DB[1]->setstate(FLT);
	m_DB[2] = m_IInstance->getdsimpin("DB2,db2", true);
	m_DB[2]->setstate(FLT);
	m_DB[3] = m_IInstance->getdsimpin("DB3,db3", true);
	m_DB[3]->setstate(FLT);
	m_DB[4] = m_IInstance->getdsimpin("DB4,db4", true);
	m_DB[4]->setstate(FLT);
	m_DB[5] = m_IInstance->getdsimpin("DB5,db5", true);
	m_DB[5]->setstate(FLT);
	m_DB[6] = m_IInstance->getdsimpin("DB6,db6", true);
	m_DB[6]->setstate(FLT);
	m_DB[7] = m_IInstance->getdsimpin("DB7,db7", true);
	m_DB[7]->setstate(FLT);
	m_DataBus = m_IInstance->getbuspin("LCD_DBUS", m_DB, 8);
	m_DataBus->settiming(100, 100, 100);
	m_DataBus->setstates(SHI,SLO,FLT);

	m_CS1 = m_IInstance->getdsimpin("CS1,cs1", true);
	m_CS1->setstate(FLT);

	m_CS2 = m_IInstance->getdsimpin("CS2,cs2", true);
	m_CS2->setstate(FLT);

	m_RST = m_IInstance->getdsimpin("$RST$,$rst$", true);
	m_RST->setstate(FLT);

	m_RW = m_IInstance->getdsimpin("R/$W$,r/$w$", true);
	m_RW->setstate(FLT);

	m_DI = m_IInstance->getdsimpin("D/$I$,d/$i$", true);
	m_DI->setstate(FLT);

	m_E = m_IInstance->getdsimpin("E,e", true);
	m_E->setstate(FLT);

	m_A = m_IInstance->getdsimpin("A,a", true);
	m_A->setstate(FLT);

	m_K = m_IInstance->getdsimpin("K,k", true);
	m_K->setstate(FLT);

	m_Chip1.Page			= 0;
	m_Chip1.Address			= 0;
	m_Chip1.StartLine		= 0;
	m_Chip1.Status			= STATUS_OFF;
	m_Chip1.isValidRead		= TRUE;
	m_Chip1.isShowDisplay	= TRUE;

	m_Chip2.Page			= 0;
	m_Chip2.Address			= 0;
	m_Chip2.StartLine		= 0;
	m_Chip2.Status			= STATUS_OFF;
	m_Chip2.isValidRead		= TRUE;
	m_Chip2.isShowDisplay	= TRUE;

	m_isRedrawDisplay	= TRUE;
	m_isRedrawPixel		= TRUE;

	m_isDisplayLight	= FALSE;
}
//------------------------------------------------------------------------------
VOID CVsmObject::runctrl(RUNMODES mode)
{
	UNREFERENCED_PARAMETER(mode);
}
//------------------------------------------------------------------------------
VOID CVsmObject::actuate(REALTIME time, ACTIVESTATE newstate)
{
	UNREFERENCED_PARAMETER(time);
	UNREFERENCED_PARAMETER(newstate);
}
//------------------------------------------------------------------------------
BOOL CVsmObject::indicate(REALTIME time, ACTIVEDATA *data)
{
	if(m_isRedrawPixel)
	{
		data->type		= ADT_REAL;
		data->realval	= (float)time * DSIMTICK;
	}

	return TRUE;
}
//------------------------------------------------------------------------------
VOID CVsmObject::simulate(ABSTIME time, DSIMMODES mode)
{
	UNREFERENCED_PARAMETER(mode);

	//********************************************************************
	if(m_CntBeforeCheckPins < 3)
	{
		_CheckStartupPins();
		++m_CntBeforeCheckPins;
	}

	if(m_CntBeforeCheckPins == 2)
		_FindFloatingPins();
	//********************************************************************

	if(PIN_RST_CHANGED)
	{
		if(PIN_RST_HI)
		{
			m_Chip1.Status	= STATUS_OFF;
			m_Chip2.Status	= STATUS_OFF;
		}

		if(PIN_RST_LO)
		{
			m_Chip1.Page			= 0;
			m_Chip1.Address			= 0;
			m_Chip1.StartLine		= 0;
			m_Chip1.isShowDisplay	= TRUE;
			m_Chip1.isValidRead		= TRUE;
			m_Chip1.Status			= STATUS_BUSY | STATUS_OFF | STATUS_RESET;

			m_Chip2.Page			= 0;
			m_Chip2.Address			= 0;
			m_Chip2.StartLine		= 0;
			m_Chip2.isShowDisplay	= TRUE;
			m_Chip2.isValidRead		= TRUE;
			m_Chip2.Status			= STATUS_BUSY | STATUS_OFF | STATUS_RESET;

			for(int i = 0; i < 64; i++)
			{
				m_Chip1.DDRAM_DRAM[i] = ((INT64)rand() << 32) + rand();
				m_Chip1.DDRAM_DRAW[i] = m_Chip1.DDRAM_DRAM[i];
				m_Chip2.DDRAM_DRAM[i] = ((INT64)rand() << 32) + rand();
				m_Chip2.DDRAM_DRAW[i] = m_Chip1.DDRAM_DRAM[i];
			}

			m_isRedrawPixel = TRUE;
		}
	}

	if(PIN_A_CHANGED || PIN_K_CHANGED)
	{
		if(PIN_A_HI && PIN_K_LO)
			m_isDisplayLight = TRUE;
		else
			m_isDisplayLight = FALSE;

		m_isRedrawDisplay	= TRUE;
		m_isRedrawPixel		= TRUE;
	}

	if(PIN_RW_CHANGED)
	{
		if(PIN_RW_LO)
			m_DataBus->drivetristate(time);
	}

	if(PIN_RW_HI)
	{
		if(PIN_E_PULSE_UP && PIN_CS1_LO && PIN_CS2_LO)
		{
			//         
			m_IInstance->warning("Reading status/data registers at the same time of two chips.");
			return;
		}

		if(PIN_E_PULSE_UP && PIN_CS1_HI && PIN_CS2_HI)
		{
			//        
			m_IInstance->warning("Reading status/data registers without select chip.");
			return;
		}
	}

	if(PIN_DI_HI)
	{
		//   

		if(PIN_RW_HI)
		{
			//    DDRAM

			if(PIN_E_PULSE_UP && PIN_CS1_LO)
				_ReadData(time, &m_Chip1);
			else if(PIN_E_PULSE_UP && PIN_CS2_LO)
				_ReadData(time, &m_Chip2);
			else if(PIN_E_HI && PIN_CS1_PULSE_DOWN)
				_ReadData(time, &m_Chip1);
			else if(PIN_E_HI && PIN_CS2_PULSE_DOWN)
				_ReadData(time, &m_Chip2);
		}
		else if(PIN_RW_LO)
		{
			//    DDRAM

			if(PIN_E_PULSE_DOWN && PIN_CS1_LO)
				_WriteData(time, &m_Chip1);

			if(PIN_E_HI && PIN_CS1_PULSE_UP)
				_WriteData(time, &m_Chip1);

			if(PIN_E_PULSE_DOWN && PIN_CS2_LO)
				_WriteData(time, &m_Chip2);

			if(PIN_E_HI && PIN_CS2_PULSE_UP)
				_WriteData(time, &m_Chip2);
		}
	}
	else if(PIN_DI_LO)
	{
		//   

		if(PIN_RW_HI)
		{
			//   

			if(PIN_E_PULSE_UP && PIN_CS1_LO)
				m_DataBus->drivebusvalue(time, m_Chip1.Status);
			else if(PIN_E_PULSE_UP && PIN_CS2_LO)
				m_DataBus->drivebusvalue(time, m_Chip2.Status);
			else if(PIN_E_HI && PIN_CS1_PULSE_DOWN)
				m_DataBus->drivebusvalue(time, m_Chip1.Status);
			else if(PIN_E_HI && PIN_CS2_PULSE_DOWN)
				m_DataBus->drivebusvalue(time, m_Chip2.Status);
		}
		else if(PIN_RW_LO)
		{
			//  

			if(PIN_E_PULSE_DOWN && PIN_CS1_LO)
				_WriteCommand(time, &m_Chip1);

			if(PIN_E_PULSE_DOWN && PIN_CS2_LO)
				_WriteCommand(time, &m_Chip2);

			if(PIN_E_HI && PIN_CS1_PULSE_UP)
				_WriteCommand(time, &m_Chip1);

			if(PIN_E_HI && PIN_CS2_PULSE_UP)
				_WriteCommand(time, &m_Chip2);
		}
	}
}
//------------------------------------------------------------------------------
void CVsmObject::_WriteCommand(ABSTIME time, CHIP * a_pChip)
{
	UNREFERENCED_PARAMETER(time);

	if(PIN_RST_LO)
	{
		m_IInstance->warning("Active RESET signal: write instruction not supported.");
		return;
	}

	int i;

	BYTE t_Data	= (BYTE)m_DataBus->getbusvalue();

	switch(t_Data & 0xC0)
	{
	case CMD_DISPLAY_SHOW:
		if((t_Data & 1) == 1)
		{
			a_pChip->isShowDisplay = TRUE;

			for(i = 0; i < 64; i++)
				a_pChip->DDRAM_DRAW[i] = _ROR(a_pChip->DDRAM_DRAM[i], a_pChip->StartLine);
		}
		else
		{
			a_pChip->isShowDisplay = FALSE;

			for(i = 0; i < 64; i++)
				a_pChip->DDRAM_DRAW[i] = 0;
		}

		m_isRedrawPixel = TRUE;
		break;

	case CMD_SET_ADDRESS:
		a_pChip->Address = (t_Data & 0x3F);
		a_pChip->isValidRead = FALSE;
		break;

	case CMD_SET_PAGE:
		a_pChip->Page = (t_Data & 0x07);
		a_pChip->isValidRead = FALSE;
		break;

	case CMD_START_LINE:
		a_pChip->StartLine = (t_Data & 0x3F);

		for(i = 0; i < 64; i++)
			if(a_pChip->isShowDisplay)
				a_pChip->DDRAM_DRAW[i] = _ROR(a_pChip->DDRAM_DRAM[i], a_pChip->StartLine);

		m_isRedrawPixel = TRUE;
		break;
	}
}
//------------------------------------------------------------------------------
void CVsmObject::_WriteData(ABSTIME time, CHIP * a_pChip)
{
	UNREFERENCED_PARAMETER(time);

	if(PIN_RST_LO)
	{
		m_IInstance->warning("Active RESET signal: write data not supported.");
		return;
	}

	DWORD64 t_Data	= m_DataBus->getbusvalue();
	DWORD64 t_Value	= a_pChip->DDRAM_DRAM[a_pChip->Address];

	t_Data <<= a_pChip->Page << 3;
	t_Value &= g_Mask[a_pChip->Page];
	t_Value |= t_Data;

	a_pChip->DDRAM_DRAM[a_pChip->Address] = t_Value;

	if(a_pChip->isShowDisplay)
		a_pChip->DDRAM_DRAW[a_pChip->Address] = _ROR(t_Value, a_pChip->StartLine);

	a_pChip->Address++;

	m_isRedrawPixel = TRUE;

	if(a_pChip->Address == 64)
		a_pChip->Address = 0;
}
//------------------------------------------------------------------------------
void CVsmObject::_ReadData(ABSTIME time, CHIP * a_pChip)
{
	if(PIN_RST_LO)
	{
		m_IInstance->warning("Active RESET signal: read data not supported.");
		return;
	}

	if(!a_pChip->isValidRead)
	{
		a_pChip->isValidRead = TRUE;
		return;
	}

	m_DataBus->drivebusvalue(time, (a_pChip->DDRAM_DRAM[a_pChip->Address++] >> (a_pChip->Page << 3)) & 0x00000000000000FF);

	if(a_pChip->Address == 64)
		a_pChip->Address = 0;
}
//------------------------------------------------------------------------------
VOID CVsmObject::callback(ABSTIME time, EVENTID eventid)
{
	UNREFERENCED_PARAMETER(time);
	UNREFERENCED_PARAMETER(eventid);
}
//------------------------------------------------------------------------------
VOID CVsmObject::initialize(ICOMPONENT *cpt)
{
	m_Icomponent = cpt;
	m_Icomponent->setpenwidth(0);
	m_Icomponent->setpencolour(BLACK);
	m_Icomponent->setbrushcolour(BLACK);

	m_Icomponent->getsymbolarea(0, &m_rcDraw);
}
//------------------------------------------------------------------------------
ISPICEMODEL *CVsmObject::getspicemodel(CHAR *primitive)
{
	UNREFERENCED_PARAMETER(primitive);

	return NULL; 
}
//------------------------------------------------------------------------------
IDSIMMODEL  *CVsmObject::getdsimmodel(CHAR *primitive)
{
	UNREFERENCED_PARAMETER(primitive);

	return this; 
}
//------------------------------------------------------------------------------
VOID CVsmObject::plot(ACTIVESTATE state)
{
	UNREFERENCED_PARAMETER(state);

	m_Icomponent->drawsymbol(-1);
	m_isRedrawDisplay	= TRUE;
	m_isRedrawPixel		= TRUE;
	animate(0, NULL);
}
//------------------------------------------------------------------------------
VOID CVsmObject::animate(INT element, ACTIVEDATA *data)
{
	UNREFERENCED_PARAMETER(element);
	UNREFERENCED_PARAMETER(data);

	_DrawObject(m_Icomponent->begincache(m_rcDraw));

	m_Icomponent->endcache();
}
//------------------------------------------------------------------------------
BOOL CVsmObject::actuate(WORD key, INT x, INT y, DWORD flags)
{
	UNREFERENCED_PARAMETER(key);
	UNREFERENCED_PARAMETER(x);
	UNREFERENCED_PARAMETER(y);
	UNREFERENCED_PARAMETER(flags);

	return FALSE; 
}
//------------------------------------------------------------------------------
void CVsmObject::_FindFloatingPins()
{
	if(PIN_CS1_FLOATING)
	{
		m_IInstance->warning("Pin CS1 is floating.");
		return;
	}

	if(PIN_CS2_FLOATING)
	{
		m_IInstance->warning("Pin CS2 is floating.");
		return;
	}

	if(PIN_RST_FLOATING)
	{
		m_IInstance->warning("Pin RST is floating.");
		return;
	}

	if(PIN_RW_FLOATING)
	{
		m_IInstance->warning("Pin RW is floating.");
		return;
	}

	if(PIN_DI_FLOATING)
	{
		m_IInstance->warning("Pin DI is floating.");
		return;
	}

	if(PIN_E_FLOATING)
	{
		m_IInstance->warning("Pin E is floating.");
		return;
	}
}
//------------------------------------------------------------------------------
void CVsmObject::_CheckStartupPins()
{
	if(PIN_A_HI && PIN_K_LO)
		m_isDisplayLight = TRUE;
	else
		m_isDisplayLight = FALSE;

	if(PIN_RST_LO)
	{
		m_Chip1.Status = STATUS_BUSY | STATUS_OFF | STATUS_RESET;
		m_Chip2.Status = STATUS_BUSY | STATUS_OFF | STATUS_RESET;
	}
	else
	{
		m_Chip1.Status = STATUS_OFF;
		m_Chip2.Status = STATUS_OFF;
	}

	m_isRedrawDisplay	= TRUE;
	m_isRedrawPixel		= TRUE;
}
//------------------------------------------------------------------------------
void CVsmObject::_DrawObject(HDC a_hDC)
{
	RECT t_Rect;
	GetClipBox(a_hDC, &t_Rect);

	if(m_isRedrawDisplay)
	{
		_CacheDisplay(a_hDC);
		m_isRedrawDisplay = FALSE;
	}

	if(m_isRedrawPixel)
	{
		_CachePixels(a_hDC);
		m_isRedrawPixel = FALSE;
	}

	BitBlt(	a_hDC,
			t_Rect.left,
			t_Rect.top,
			t_Rect.right - t_Rect.left,
			t_Rect.bottom - t_Rect.top,
			m_DcPixel,
			t_Rect.left,
			t_Rect.top,
			SRCCOPY	);
}
//------------------------------------------------------------------------------
void CVsmObject::_CacheDisplay(HDC a_hDC)
{
	if(m_DcDisplay != NULL)
	{
		SelectObject(m_DcDisplay, m_OldBmpDisplay);
		DeleteObject(m_BmpDisplay);
	}
	else
		m_DcDisplay = CreateCompatibleDC(a_hDC);

	RECT t_Rect;
	GetClipBox(a_hDC, &t_Rect);

	m_BmpDisplay = CreateCompatibleBitmap(	a_hDC,
											t_Rect.right - t_Rect.left,
											t_Rect.bottom - t_Rect.top	);

	m_OldBmpDisplay = (HBITMAP)SelectObject(m_DcDisplay, m_BmpDisplay);
//	SetWindowOrgEx(m_hMemDcDisplay, , , NULL);

	double t_PixelWidth		= (double)(t_Rect.right - t_Rect.left) / 132.0;
	double t_PixelHeight	= (double)(t_Rect.bottom - t_Rect.top) / 68.0;

	int t_BorderWidth	= (int)(t_PixelWidth * 2.0 / 3.0);
	int t_BorderHeight	= (int)(t_PixelHeight * 2.0 / 3.0);

	if(t_BorderWidth < 1) t_BorderWidth = 1;
	if(t_BorderHeight < 1) t_BorderHeight = 1;

	HBRUSH t_Brush = CreateSolidBrush(RGB(0, 0, 0));
	FillRect(m_DcDisplay, &t_Rect, t_Brush);
	DeleteObject(t_Brush);

	if(m_isDisplayLight)
		t_Brush = CreateSolidBrush(RGB(181, 244, 0));
	else
		t_Brush = CreateSolidBrush(RGB(122, 150, 134));

	RECT t_RectBk;

	t_RectBk.left	= t_Rect.left + t_BorderWidth;
	t_RectBk.top	= t_Rect.top + t_BorderHeight;
	t_RectBk.right	= t_Rect.right - t_BorderWidth;
	t_RectBk.bottom	= t_Rect.bottom - t_BorderHeight;

	FillRect(m_DcDisplay, &t_RectBk, t_Brush);
	DeleteObject(t_Brush);

	TRIVERTEX        vert[2];
	GRADIENT_RECT    gRect;

	vert[0].x			= t_Rect.left + (LONG)(t_PixelWidth * 2.0);
	vert[0].y			= t_Rect.top + (LONG)(t_PixelHeight * 2.0);
	vert[0].Alpha		= 0x0000;
	if(m_isDisplayLight)
	{
		vert[0].Red		= 132 << 8;
		vert[0].Green	= 177 << 8;
		vert[0].Blue	= 0;
	}
	else
	{
		vert[0].Red		= 72 << 8;
		vert[0].Green	= 99 << 8;
		vert[0].Blue	= 83 << 8;
	}

	vert[1].x			= t_Rect.right - (LONG)(t_PixelWidth * 2.0);
	vert[1].y			= t_Rect.bottom - (LONG)(t_PixelHeight * 2.0);
	vert[1].Alpha		= 0x0000;
	if(m_isDisplayLight)
	{
		vert[1].Red		= 156 << 8;
		vert[1].Green	= 209 << 8;
		vert[1].Blue	= 0;
	}
	else
	{
		vert[1].Red		= 100 << 8;
		vert[1].Green	= 128 << 8;
		vert[1].Blue	= 112 << 8;
	}

	gRect.UpperLeft  = 0;
	gRect.LowerRight = 1;

	GradientFill(m_DcDisplay, vert, 2, &gRect, 1, GRADIENT_FILL_RECT_V);
}
//------------------------------------------------------------------------------
void CVsmObject::_CachePixels(HDC a_hDC)
{
	if(m_DcPixel != NULL)
	{
		SelectObject(m_DcPixel, m_OldBmpPixel);
		DeleteObject(m_BmpPixel);
	}
	else
		m_DcPixel = CreateCompatibleDC(a_hDC);

	RECT t_Rect;
	GetClipBox(a_hDC, &t_Rect);

	m_BmpPixel = CreateCompatibleBitmap(	a_hDC,
											t_Rect.right - t_Rect.left,
											t_Rect.bottom - t_Rect.top	);

	m_OldBmpPixel = (HBITMAP)SelectObject(m_DcPixel, m_BmpPixel);
//	SetWindowOrgEx(m_hMemDcPixel, , , NULL);

	BitBlt(	m_DcPixel,
			t_Rect.left,
			t_Rect.top,
			t_Rect.right - t_Rect.left,
			t_Rect.bottom - t_Rect.top,
			m_DcDisplay,
			t_Rect.left,
			t_Rect.top,
			SRCCOPY	);

	double t_PixelWidth		= (double)(t_Rect.right - t_Rect.left) / 132.0;
	double t_PixelHeight	= (double)(t_Rect.bottom - t_Rect.top) / 68.0;

	HBRUSH t_Brush = CreateSolidBrush(RGB(0, 0, 0));

	DWORD64 t_Bits;

	double t_PosX, t_PosY;
	RECT t_RectPixel;

	CHIP *t_Chips[] = {&m_Chip1, &m_Chip2};

	for(int chip = 0; chip < 2; chip++)
	{
		for(int address = 0; address < 64; address++)
		{
			t_Bits = t_Chips[chip]->DDRAM_DRAW[address];

			for(int line = 0; line < 64; line++)
			{

				t_PosX = t_PixelWidth * (double)(2 + address) + (double)chip * 64.0 * t_PixelWidth;
				t_PosY = t_PixelHeight * (double)(2 + line);

				t_RectPixel.left	= (LONG)t_PosX;
				t_RectPixel.right	= (LONG)(t_PosX + t_PixelWidth);

				if(((t_Bits >> line) & 1 ) == 0)
					continue;

				t_RectPixel.top		= (LONG)t_PosY;
				t_RectPixel.bottom	= (LONG)(t_PosY + t_PixelHeight);

				FillRect(m_DcPixel, &t_RectPixel, t_Brush);
			}
		}
	}

	DeleteObject(t_Brush);
}
//------------------------------------------------------------------------------
DWORD64 CVsmObject::_ROR(DWORD64 a_Value, DWORD a_Shift)
{
	for(DWORD i = 0; i < a_Shift; i++)
	{
		if((a_Value & 1) == 0)
			a_Value >>= 1;
		else
			a_Value = (a_Value >> 1) | 0x8000000000000000;
	}

	return a_Value;
}
//------------------------------------------------------------------------------
