/*******************************************************************************
*   . (C) 1997 Opium Inc., 
*
* :			VsmObject.h
*
* :		 . 
*
* :		03.12.2009   09:21
*
* :	self
*
* :		
*
*******************************************************************************/

#ifndef __VSMOBJECT_H__
#define __VSMOBJECT_H__

#pragma once

#include "vsm.hpp"

//------------------------------------------------------------------------------

#define STATUS_BUSY		0x80
#define STATUS_OFF		0x20
#define STATUS_RESET	0x10

//------------------------------------------------------------------------------

#define CMD_DISPLAY_SHOW	0x00
#define CMD_SET_ADDRESS		0x40
#define CMD_SET_PAGE		0x80
#define CMD_START_LINE		0xC0

//------------------------------------------------------------------------------

const DWORD64 g_Mask[8] =
{
	0xFFFFFFFFFFFFFF00,
	0xFFFFFFFFFFFF00FF,
	0xFFFFFFFFFF00FFFF,
	0xFFFFFFFF00FFFFFF,
	0xFFFFFF00FFFFFFFF,
	0xFFFF00FFFFFFFFFF,
	0xFF00FFFFFFFFFFFF,
	0x00FFFFFFFFFFFFFF
};

//------------------------------------------------------------------------------
typedef struct _tagCHIP
{
	BYTE	Status;

	DWORD	Page;
	DWORD	Address;
	DWORD	StartLine;

	BOOL	isValidRead;
	BOOL	isShowDisplay;

	DWORD64	DDRAM_DRAM[64];
	DWORD64	DDRAM_DRAW[64];
}
CHIP;

//------------------------------------------------------------------------------

#define PIN_CS1_HI			(ishigh(m_CS1->istate()))
#define PIN_CS1_LO			(islow(m_CS1->istate()))
#define PIN_CS1_CHANGED		(!m_CS1->issteady())
#define PIN_CS1_PULSE_UP	(m_CS1->isposedge()) // 0 -> 1
#define PIN_CS1_PULSE_DOWN	(m_CS1->isnegedge()) // 1 -> 0
#define PIN_CS1_FLOATING	(isfloating(m_CS1->istate()) || !isdefined(m_CS1->istate()))

#define PIN_CS2_HI			(ishigh(m_CS2->istate()))
#define PIN_CS2_LO			(islow(m_CS2->istate()))
#define PIN_CS2_CHANGED		(!m_CS2->issteady())
#define PIN_CS2_PULSE_UP	(m_CS2->isposedge()) // 0 -> 1
#define PIN_CS2_PULSE_DOWN	(m_CS2->isnegedge()) // 1 -> 0
#define PIN_CS2_FLOATING	(isfloating(m_CS2->istate()) || !isdefined(m_CS2->istate()))

#define PIN_RST_HI			(ishigh(m_RST->istate()))
#define PIN_RST_LO			(islow(m_RST->istate()))
#define PIN_RST_CHANGED		(!m_RST->issteady())
#define PIN_RST_PULSE_UP	(m_RST->isposedge()) // 0 -> 1
#define PIN_RST_PULSE_DOWN	(m_RST->isnegedge()) // 1 -> 0
#define PIN_RST_FLOATING	(isfloating(m_RST->istate()) || !isdefined(m_RST->istate()))

#define PIN_RW_HI			(ishigh(m_RW->istate()))
#define PIN_RW_LO			(islow(m_RW->istate()))
#define PIN_RW_CHANGED		(!m_RW->issteady())
#define PIN_RW_PULSE_UP		(m_RW->isposedge()) // 0 -> 1
#define PIN_RW_PULSE_DOWN	(m_RW->isnegedge()) // 1 -> 0
#define PIN_RW_FLOATING		(isfloating(m_RW->istate()) || !isdefined(m_RW->istate()))

#define PIN_DI_HI			(ishigh(m_DI->istate()))
#define PIN_DI_LO			(islow(m_DI->istate()))
#define PIN_DI_CHANGED		(!m_DI->issteady())
#define PIN_DI_PULSE_UP		(m_DI->isposedge()) // 0 -> 1
#define PIN_DI_PULSE_DOWN	(m_DI->isnegedge()) // 1 -> 0
#define PIN_DI_FLOATING		(isfloating(m_DI->istate()) || !isdefined(m_DI->istate()))

#define PIN_E_HI			(ishigh(m_E->istate()))
#define PIN_E_LO			(islow(m_E->istate()))
#define PIN_E_CHANGED		(!m_E->issteady())
#define PIN_E_PULSE_UP		(m_E->isposedge()) // 0 -> 1
#define PIN_E_PULSE_DOWN	(m_E->isnegedge()) // 1 -> 0
#define PIN_E_FLOATING		(isfloating(m_E->istate()) || !isdefined(m_E->istate()))

#define PIN_A_HI			(ishigh(m_A->istate()))
#define PIN_A_LO			(islow(m_A->istate()))
#define PIN_A_CHANGED		(!m_A->issteady())
#define PIN_A_PULSE_UP		(m_A->isposedge()) // 0 -> 1
#define PIN_A_PULSE_DOWN	(m_A->isnegedge()) // 1 -> 0
#define PIN_A_FLOATING		(isfloating(m_A->istate()) || !isdefined(m_A->istate()))

#define PIN_K_HI			(ishigh(m_K->istate()))
#define PIN_K_LO			(islow(m_K->istate()))
#define PIN_K_CHANGED		(!m_K->issteady())
#define PIN_K_PULSE_UP		(m_K->isposedge()) // 0 -> 1
#define PIN_K_PULSE_DOWN	(m_K->isnegedge()) // 1 -> 0
#define PIN_K_FLOATING		(isfloating(m_K->istate()) || !isdefined(m_K->istate()))

//------------------------------------------------------------------------------

class CVsmObject :	public IACTIVEMODEL,
					public IDSIMMODEL
{
public:
	// virtual method by IACTIVEMODEL
	virtual VOID initialize (ICOMPONENT *cpt);
	virtual ISPICEMODEL *getspicemodel (CHAR *primitive);
	virtual IDSIMMODEL  *getdsimmodel (CHAR *primitive);
	virtual VOID plot (ACTIVESTATE state);
	virtual VOID animate (INT element, ACTIVEDATA *newstate);
	virtual BOOL actuate (WORD key, INT x, INT y, DWORD flags);

	// virtual method by IDSIMMODEL
	virtual INT  isdigital (CHAR *pinname);
	virtual VOID setup (IINSTANCE *instance, IDSIMCKT *dsim);
	virtual VOID runctrl (RUNMODES mode);
	virtual VOID actuate (REALTIME time, ACTIVESTATE newstate);
	virtual BOOL indicate (REALTIME time, ACTIVEDATA *newstate);
	virtual VOID simulate (ABSTIME time, DSIMMODES mode);
	virtual VOID callback (ABSTIME time, EVENTID eventid);

public:
	CVsmObject();
	virtual ~CVsmObject();

protected:
	void _FindFloatingPins();
	void _CheckStartupPins();
	void _DrawObject(HDC a_hDC);
	void _CacheDisplay(HDC a_hDC);
	void _CachePixels(HDC a_hDC);

	void _WriteCommand(ABSTIME time, CHIP * a_pChip);
	void _WriteData(ABSTIME time, CHIP * a_pChip);
	void _ReadData(ABSTIME time, CHIP * a_pChip);
	DWORD64 _ROR(DWORD64 a_Value, DWORD a_Shift);

protected:
	IINSTANCE*	m_IInstance;
	IDSIMCKT*	m_Ickt;
	ICOMPONENT*	m_Icomponent;

	IDSIMPIN*	m_DB[8];
	IBUSPIN		*m_DataBus;

	IDSIMPIN*	m_CS1;
	IDSIMPIN*	m_CS2;
	IDSIMPIN*	m_RST;
	IDSIMPIN*	m_RW;
	IDSIMPIN*	m_DI;
	IDSIMPIN*	m_E;
	IDSIMPIN*	m_A;
	IDSIMPIN*	m_K;

	BOX			m_rcDraw;

	BOOL		m_isRedrawDisplay;
	BOOL		m_isRedrawPixel;

	HDC			m_DcDisplay;
	HBITMAP		m_BmpDisplay;
	HBITMAP		m_OldBmpDisplay;

	HDC			m_DcPixel;
	HBITMAP		m_BmpPixel;
	HBITMAP		m_OldBmpPixel;

	CHIP		m_Chip1; // left
	CHIP		m_Chip2; // right

	BOOL		m_isDisplayLight;

	int			m_CntBeforeCheckPins;
};

//------------------------------------------------------------------------------

#endif